#include <gnome.h>
#include <string.h>

/*
green
blue
red
white
silver (grey)
yellow
magenta (purple)
cyan
black
*/

#include "bmud.h"
/* #include "version.h" */

/*
 * Local Functions
 */
gushort convert_color (unsigned color);
void    extract_color (GdkColor *color,
                       unsigned red,
                       unsigned green,
                       unsigned blue);

/*
 * Global Variables
 */
GtkWidget *text_field;
GtkWidget *text_entry;
GtkWidget *entry_host;
GtkWidget *entry_port;

/*
 * Colors...
 */
GdkColormap *cmap;
GdkColor color_white;
GdkColor color_black;
GdkColor color_blue;
GdkColor color_green;
GdkColor color_red;
GdkColor color_brown;
GdkColor color_purple;
GdkColor color_orange;
GdkColor color_yellow;
GdkColor color_lightgreen;
GdkColor color_cyan;
GdkColor color_lightcyan;
GdkColor color_lightblue;
GdkColor color_pink;
GdkColor color_grey;
GdkColor color_lightgrey;

GdkFont  *display_font;

/* from bezerk */
gushort convert_color (unsigned c)
{
    if ( c == 0 )
        return 0;
    c *= 257;

    return (c > 0xffff) ? 0xffff : c;
}

/* from bezerk */
void extract_color (GdkColor *color, unsigned red, unsigned green, unsigned blue)
{
    color->red   = convert_color (red);
    color->green = convert_color (green);
    color->blue  = convert_color (blue);
}

/* from bezerk */
void init_colors ()
{
//    display_font = gdk_font_load ("fixed");
    
    cmap = gdk_colormap_get_system ();
    
    extract_color(&color_white, 255, 255, 255);
    if (!gdk_color_alloc(cmap, &color_white)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_black, 0, 0, 0);
    if (!gdk_color_alloc(cmap, &color_black)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_blue, 0, 100, 255);
    if (!gdk_color_alloc(cmap, &color_blue)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_green, 0, 255, 0);
    if (!gdk_color_alloc(cmap, &color_green)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_red, 255, 0, 0);
    if (!gdk_color_alloc(cmap, &color_red)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_brown, 165, 42, 42);
    if (!gdk_color_alloc(cmap, &color_brown)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_purple, 160, 32, 240);
    if (!gdk_color_alloc(cmap, &color_purple)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_orange, 255, 165, 0);
    if (!gdk_color_alloc(cmap, &color_orange)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_yellow, 255, 255, 0);
    if (!gdk_color_alloc(cmap, &color_yellow)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_lightgreen, 144, 238, 144);
    if (!gdk_color_alloc(cmap, &color_lightgreen)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_cyan, 0, 255, 255);
    if (!gdk_color_alloc(cmap, &color_cyan)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_lightcyan, 224, 255, 255);
    if (!gdk_color_alloc(cmap, &color_lightcyan)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_lightblue, 173, 216, 230);
    if (!gdk_color_alloc(cmap, &color_lightblue)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_pink, 255, 192, 203);
    if (!gdk_color_alloc(cmap, &color_pink)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_grey, 190, 190, 190);
    if (!gdk_color_alloc(cmap, &color_grey)) {
        g_error("couldn't allocate color");
    }

    extract_color(&color_lightgrey, 211, 211, 211);
    if (!gdk_color_alloc(cmap, &color_lightgrey)) {
        g_error("couldn't allocate color");
    }
}

GdkColor getcol(char *tmp, int bleh){
	g_print("%d  %s\n",bleh,tmp);
	switch(bleh){
		case 2: if(!strncmp(tmp,"[m",2))return color_white; 
			break;
		case 3: if(!strncmp(tmp,"[1m",3))return color_white; break;
		case 4:
			if(!strncmp(tmp,"[30m",4))return color_grey;
			if(!strncmp(tmp,"[31m",4))return color_red;
			if(!strncmp(tmp,"[32m",4))return color_green;
			if(!strncmp(tmp,"[33m",4))return color_yellow;
			if(!strncmp(tmp,"[34m",4))return color_blue;
			if(!strncmp(tmp,"[35m",4))return color_purple;
			if(!strncmp(tmp,"[36m",4))return color_cyan;
			if(!strncmp(tmp,"[37m",4))return color_white;
			break;
		case 6:
			if(!strncmp(tmp,"[0;30m",6))return color_grey;
			if(!strncmp(tmp,"[0;31m",6))return color_red;
			if(!strncmp(tmp,"[0;32m",6))return color_green;
			if(!strncmp(tmp,"[0;33m",6))return color_yellow;
			if(!strncmp(tmp,"[0;34m",6))return color_blue;
			if(!strncmp(tmp,"[0;35m",6))return color_purple;
			if(!strncmp(tmp,"[0;36m",6))return color_cyan;
			if(!strncmp(tmp,"[0;37m",6))return color_white;
			if(!strncmp(tmp,"[1;30m",6))return color_grey;
			if(!strncmp(tmp,"[1;31m",6))return color_red;
			if(!strncmp(tmp,"[1;32m",6))return color_green;
			if(!strncmp(tmp,"[1;33m",6))return color_yellow;
			if(!strncmp(tmp,"[1;34m",6))return color_blue;
			if(!strncmp(tmp,"[1;35m",6))return color_purple;
			if(!strncmp(tmp,"[1;36m",6))return color_cyan;
			if(!strncmp(tmp,"[1;37m",6))return color_white;
			if(!strncmp(tmp,"[J",2))return color_white;
			break;
		case 8:
			if(!strncmp(tmp,"[0;1;30m",8))return color_grey;
			if(!strncmp(tmp,"[0;1;31m",8))return color_red;
			if(!strncmp(tmp,"[0;1;32m",8))return color_green;
			if(!strncmp(tmp,"[0;1;33m",8))return color_yellow;
			if(!strncmp(tmp,"[0;1;34m",8))return color_blue;
			if(!strncmp(tmp,"[0;1;35m",8))return color_purple;
			if(!strncmp(tmp,"[0;1;36m",8))return color_cyan;
			if(!strncmp(tmp,"[0;1;37m",8))return color_white;
			if(!strncmp(tmp,"[0;0;30m",8))return color_grey;
			if(!strncmp(tmp,"[0;0;31m",8))return color_red;
			if(!strncmp(tmp,"[0;0;32m",8))return color_green;
			if(!strncmp(tmp,"[0;0;33m",8))return color_yellow;
			if(!strncmp(tmp,"[0;0;34m",8))return color_blue;
			if(!strncmp(tmp,"[0;0;35m",8))return color_purple;
			if(!strncmp(tmp,"[0;0;36m",8))return color_cyan;
			if(!strncmp(tmp,"[0;0;37m",8))return color_white;
			if(!strncmp(tmp,"[0;5;30m",8))return color_grey;
			if(!strncmp(tmp,"[0;5;31m",8))return color_red;
			if(!strncmp(tmp,"[0;5;32m",8))return color_green;
			if(!strncmp(tmp,"[0;5;33m",8))return color_yellow;
			if(!strncmp(tmp,"[0;5;34m",8))return color_blue;
			if(!strncmp(tmp,"[0;5;35m",8))return color_purple;
			if(!strncmp(tmp,"[0;5;36m",8))return color_cyan;
			if(!strncmp(tmp,"[0;5;37m",8))return color_white;
			break;
		default:
			return color_white;
		}
	return color_white;
	}

void disp_ansi(int size, gchar *in, GtkWidget *target){
	GdkColor col=color_white;
	int n=0,x=0;	/* in[n], x is sizeof ansi code */
	char tmp[9];

	gtk_text_freeze(GTK_TEXT(target));
	while(n<size){
		if(in[n]!=27)
			gtk_text_insert(GTK_TEXT(target),NULL,&col,NULL,&in[n],1);
		else {
			while(in[x+n]!='m')x++;
		if(x<9){

			memset(tmp,0,9); 
			memcpy(tmp,&in[n+1],x);
			col=getcol(tmp,x);			

		}
			n+=x;
			x=0;
			}
		n++;
		}			
	gtk_text_thaw(GTK_TEXT(target));
	return;
	}
